

import java.util.ArrayList;
import java.util.List;

import java.util.concurrent.Callable;
import java.util.concurrent.Executors;
import java.util.concurrent.ExecutorService;

public class useEnergySource {

  private static final EnergySource energySource = EnergySource.create();

  public static void main(final String[] args) {
    try {
      System.out.println(
        "Energy level at start: " + energySource.getUnitsAvailable());

      List<Callable<Object>> tasks = new ArrayList<Callable<Object>>();

      for (int i = 0; i < 10; i++) {
        tasks.add(
          new Callable<Object>() {
            public Object call() {
              for (int j = 0; j < 7; j++) {
                energySource.useEnergy(1);
              }
              return null;
            }
          });
      }


      final ExecutorService service = Executors.newFixedThreadPool(10);
      service.invokeAll(tasks);
      System.out.println(
        "Energy level at end: " + energySource.getUnitsAvailable());
      System.out.println("Usage: " + energySource.getUsageCount());
      energySource.stopEnergySource();
      service.shutdown();
      energySource.shutdown();

    } catch (Exception ex) {
      ex.printStackTrace();
    }
  }

}
